%define anolis_release 1
%global devrel 1

Summary: A text-based Web browser
Name: lynx
Version: 2.8.9
Release: %{anolis_release}%{?dist}
License: GPLv2
Source0: https://invisible-mirror.net/archives/lynx/tarballs/lynx%{version}rel.%{devrel}.tar.bz2
URL: http://lynx.browser.org/

Patch1: lynx-2.8.9-build.patch
Patch2: lynx-CVE-2008-4690.patch
# avoid build failure caused by mistakenly excluded <locale.h>
Patch3: lynx-2.8.8-locale.patch
Patch4: lynx-2.8.9-static-analysis.patch
Patch5: lynx-2.8.9-CVE-2021-38165.patch

Provides: webclient
Provides: text-www-browser
BuildRequires: dos2unix
BuildRequires: gcc
BuildRequires: gettext
BuildRequires: make
BuildRequires: ncurses-devel
BuildRequires: openssl-devel
BuildRequires: telnet
BuildRequires: unzip
BuildRequires: zip
BuildRequires: zlib-devel

%description
Lynx is a text-based Web browser. Lynx does not display any images,
but it does support frames, tables, and most other HTML tags. One
advantage Lynx has over graphical browsers is speed; Lynx starts and
exits quickly and swiftly displays web pages.

%package doc
Summary: Doc files for %{name}
Requires: %{name} = %{EVR}
BuildArch: noarch

%description doc
Doc files for %{name}

%prep
%autosetup -p1 -n lynx2.8.9rel.%{devrel}

sed -e "s,^HELPFILE:.*,HELPFILE:file://localhost%{_pkgdocdir}/lynx_help/lynx_help_main.html,g" -i lynx.cfg
sed -e 's,^STARTFILE:.*,STARTFILE:file:/usr/share/doc/HTML/en-US/index.html,' -i lynx.cfg

%build
%configure --libdir=/etc            \
    --disable-font-switch           \
    --disable-rpath-hack            \
    --enable-addrlist-page          \
    --enable-charset-choice         \
    --enable-cgi-links              \
    --enable-cjk                    \
    --enable-debug                  \
    --enable-default-colors         \
    --enable-externs                \
    --enable-file-upload            \
    --enable-internal-links         \
    --enable-ipv6                   \
    --enable-japanese-utf8          \
    --enable-justify-elts           \
    --enable-locale-charset         \
    --enable-kbd-layout             \
    --enable-libjs                  \
    --enable-nls                    \
    --enable-nsl-fork               \
    --enable-persistent-cookies     \
    --enable-prettysrc              \
    --enable-read-eta               \
    --enable-scrollbar              \
    --enable-source-cache           \
    --enable-warnings               \
    --with-screen=ncursesw          \
    --with-ssl=%{_libdir}           \
    --with-zlib                     \
    ac_cv_path_RLOGIN=/usr/bin/rlogin

make -C po
%make_build

# remove zero-length tests files to silence rpmlint
rm -fv test/X test/nobody

%install
chmod -x samples/mailto-form.pl
%make_install

# remove unneeded files with incompatible encoding
rm -f docs/{OS-390.announce,README.jp}
rm -f samples/*.bat

# convert line endings
dos2unix samples/lynx-demo.cfg
dos2unix samples/midnight.lss

# Install Lang dependent resources
mkdir -p %{buildroot}/usr/share/locale/ja/LC_MESSAGES/

cat >%{buildroot}%{_sysconfdir}/lynx-site.cfg <<EOF
# Place any local lynx configuration options (proxies etc.) here.
EOF

%find_lang %{name}

%files -f %{name}.lang
%license COPYING
%doc test lynx.hlp lynx_help
%{_bindir}/lynx
%{_mandir}/*/*
%config(noreplace) %{_sysconfdir}/lynx.cfg
%config(noreplace) %{_sysconfdir}/lynx.lss
%config(noreplace,missingok) %{_sysconfdir}/lynx-site.cfg

%files doc
%doc docs README INSTALLATION samples

%changelog
* Thu Mar 16 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.8.9-1
- init from upstream
